(* W07 *)
(** Implementation of Towers of Hanoi *)
type t
(** the type of a Towers of Hanoi problem *)
exception Peg_empty
(** if peg is empty *)
exception Peg_too_small
(** if element can not be pushed on peg *)

val debugging: unit -> unit 
(** [debugging ()] toggles debugging on/off *)
val make: int -> t
(** [make n] generates starting problem of size [n] *)
val move: int -> int -> t -> t
(** [move i j ts] moves top element from peg [i] to peg [j]. 
 @raise Peg_empty if peg [i] is empty
 @raise Peg_too_small if top element of peg [i] cannot be pushed on peg [j]
*)
val solved: t -> bool
(** [solved ts] checks if towers [ts] are solved *)
val print: t -> unit
(** [print ts] prints towers [ts] *)

